Description

Huge fan of your app, seems to be a lot of clients using it and it’s proving to be a great way to get instant results for a lot of

eComm heavy and branding focused organisations.

I’ve been trying to roll it out for a client of mine and it appears that it’s struggling with certain URLs running over HTTPS on IIS.

For example, when we try to hit up https://www.penfolds.com within the app, it fails to connect. After a fair bit of digging around,

it appears to be down to how IIS handles SSL requests, as highlighted here:

http://blog.helge.net/2014/06/error-connecting-with-openssl-sclient.html

I tried to connect via OpenSSL with:

s_client –connect www.penfolds.com:443

This immediately returns an errorno=54

I can successfully connect with:

s_client –connect www.penfolds.com:443 –servername www.penfolds.com

Hooray for IIS.

That being said, do you think you may be able to add/fix this particular feature in a release for this app in the future? I guess a

checkbox/field combo box to add a “–servername" argument when creating the input would be best, but I’m no app-creating

genius, and there may be better ways to go about this.

Let me know if you have any questions about this particular issue; happy to give you more background.

References:

http://blog.helge.net/2014/06/error-connecting-with-openssl-sclient.html

https://docs.python.org/2/whatsnew/2.7.html#pep-466-network-security-enhancements-for-python-2-7 (this may have been fixed

in python 2.7)

History

#1 - 08/25/2015 06:08 AM - Luke Murphey

Might be related: https://github.com/DataDog/dd-agent/issues/1196

#2 - 08/25/2015 04:05 PM - Luke Murphey

Adding the host doesn't seem to work. It appears that httplib2 provides this by itself.

#3 - 08/25/2015 04:05 PM - Luke Murphey

My problem might be SNI: http://docs.python-requests.org/en/latest/community/faq/
#4 - 08/25/2015 04:07 PM - Luke Murphey

It appears this may never work: https://code.google.com/p/httplib2/issues/detail?id=233

#5 - 08/25/2015 04:12 PM - Luke Murphey

I don't think I can fix this. From what I can tell, you need support from the SSL libs (

https://stackoverflow.com/questions/18578439/using-requests-with-tls-doesnt-give-sni-support/18579484#18579484). I cannot install these from an

app though.

#6 - 08/25/2015 04:16 PM - Luke Murphey

http://sourceforge.net/p/httplib2/mailman/message/302651/

#7 - 08/25/2015 04:21 PM - Luke Murphey

Going to try using the requests library version 2.5.1 (https://github.com/kennethreitz/requests/releases/tag/v2.5.1).

#8 - 08/25/2015 04:22 PM - Luke Murphey

BTW: look at the unit test testSslHostnameValidation here: https://github.com/kerin/httplib2/blob/master/python2/httplib2test.py

Thats a good test for SNI support (or lack thereof).

#9 - 08/25/2015 04:25 PM - Luke Murphey

Requests seems to work:

import requests

r = requests.get('https://www.penfolds.com')

r.status_code # Is 200

#10 - 08/25/2015 05:53 PM - Luke Murphey

Need to enable proxy support: https://scraperjs.wordpress.com/2013/11/26/using-socks-proxy-in-python-for-httphttps-requests/

#11 - 08/25/2015 06:29 PM - Luke Murphey

This isn't working even after converting to requests. It appears that the unit tests succeed with Splunk's Python interpreter, but fail when running

within Splunk.

#12 - 08/25/2015 06:33 PM - Luke Murphey

Scratch that; I think this should work if Splunk is upgraded since SNI works on python 2.7.9 and up.

#13 - 08/25/2015 07:50 PM - Luke Murphey

Need to make sure timeouts are recognized too.

#14 - 08/25/2015 07:50 PM - Luke Murphey

Timeouts are not being raised like this: http://www.mobify.com/blog/http-requests-are-hard/

#15 - 08/25/2015 07:52 PM - Luke Murphey

How to set timeout: https://urllib3.readthedocs.org/en/latest/index.html#timeout
#16 - 08/25/2015 09:47 PM - Luke Murphey

http://stackoverflow.com/questions/12601316/how-to-make-python-requests-work-via-socks-proxy

pysocks supposedly works: http://dae.me/blog/1959/using-pythons-urllib2-or-requests-with-a-socks5-proxy/

Another solution: https://seanmckaybeck.com/wrapping-python-requests-in-a-socks5-proxy.html

#17 - 08/26/2015 04:33 AM - Luke Murphey

- Status changed from New to In Progress

- Target version set to 1.3

- % Done changed from 0 to 70

#18 - 08/26/2015 05:04 AM - Luke Murphey

Splunk 6.2.5 ships with Python 2.7.8. It appears that 6.3.0 is a minimum to achieve SNI support.

#19 - 08/26/2015 05:04 AM - Luke Murphey

- % Done changed from 70 to 100

#20 - 08/27/2015 04:20 PM - Luke Murphey

- Status changed from In Progress to Closed
